import BigNumber from "bignumber.js";
import { getTokenAllowance } from "./getTokenAllowance";

export const needsApproval = (
  chainId: number,
  account: string,
  tokenAddress: string,
  spenderAddress: string
): Promise<Boolean> => {
  return getTokenAllowance(chainId, account, tokenAddress, spenderAddress).then(
    (allowance) => {
      return new BigNumber(allowance).eq(0);
    }
  );
};
