import { web3Instance } from "../factory";

export const getNativeBalance = (
  chainId: number,
  account: string
): Promise<string> => {
  if (!chainId) console.warn("No chainId provided. Using BSC [56] as default");
  if (!account) {
    console.warn("No account provided.");
    return Promise.resolve("0");
  }

  const web3 = web3Instance.getInstance(chainId);

  return web3.eth.getBalance(account);
};
