import { createContract } from "../utils/createContract";

export const deposit = (
  addressContract: string,
  library: any,
  params: any[],
  abi?: any
) => {
  const contract = createContract(abi, library, addressContract);

  if (!contract) return;

  return contract.deposit(...params).then((response) => {
    console.debug("Deposit transaction sent successfully");
    return response.wait().then((response) => {
      console.debug(`Transaction ${response.transactionHash} confirmed`);
      return response;
    });
  });
};
