import BigNumber from "bignumber.js";
import { callFunction, callViewFunction } from ".";

const solveSingle = (arr: any[]) => {
  arr = arr.slice();
  while (arr.length - 1) {
    if (arr[1] === "*")
      arr[0] = new BigNumber(arr[0]).times(new BigNumber(arr[2]));
    if (arr[1] === "-")
      arr[0] = new BigNumber(arr[0]).minus(new BigNumber(arr[2]));
    if (arr[1] === "+")
      arr[0] = new BigNumber(arr[0]).plus(new BigNumber(arr[2]));
    if (arr[1] === "/")
      arr[0] = new BigNumber(arr[0]).dividedBy(new BigNumber(arr[2]));
    arr.splice(1, 1);
    arr.splice(1, 1);
  }
  return arr[0];
};

export const solve = (chainId: number, eq: string) => {
  let res = eq.split(/(\+|-)/g).map((x) =>
    x
      .trim()
      .split(/(\*|\/)/g)
      .map((a) => a.trim())
  );

  const values = resolveContractValue(chainId, res);

  return Promise.all(values).then((response) => {
    res = response.map((x) => solveSingle([x]));
    return solveSingle(res);
  });
};

const resolveContractValue = (chainId, array: any[]) => {
  const test = ["*", "-", "+", "/"];
  let arr = array.flat();
  return arr.map((i) => {
    console.debug("i", i);
    if (test.includes(i) || !isNaN(i)) return i;

    const object = JSON.parse(i);

    if (object.isView) {
      return callViewFunction(
        chainId,
        object.contract,
        object.params,
        object.fnToCall,
        object.abi
      );
    } else {
      return callFunction(
        object.contract,
        object.library,
        object.params,
        object.fnToCall,
        object.abi
      );
    }
  });
};
